/* 
 * File:   Bone.h
 * Author: Trixt0r
 *
 * Created on 19. April 2012, 20:39
 */

#ifndef BONE_H
#define	BONE_H

#include <math.h>
#define DEGTORAD(angle) (angle)*(M_PI/180.0)
#define noone -4

#include <vector>
#include "Skeleton.h"
#include "Animation.h"

class Animation;
class Bone {
public:
    std::vector<Bone*> *children;
    Animation *animation;
    double count;
    unsigned int index;
    Bone *parent;
    double sprite,sprite_x,sprite_y,sprite_index,sprite_length,sprite_dir,sprite_angle,sprite_depth,sprite_xscale,sprite_yscale,
    joint,joint_x,joint_y,joint_index,joint_length,joint_dir,joint_angle,joint_depth,joint_xscale,joint_yscale,
    x,y,angle,scale,added_angle,parent_angle,parent_length,parent_scale,
    xscale,yscale,xrot,yrot,origin_x,origin_y,skel_x,skel_y,anim_x,anim_y;
    char *name;
    
    Bone(char *name,Bone *parent,double x,double y,double angle, double scale, unsigned int index);
    Bone(const Bone& orig);
    virtual ~Bone();
    /*Assigns a sprite or a joint to the bone.*/
    void set_sprite(double sprite_index,double x, double y, double depth, bool joint);
    /*Update position and rotation.*/
    void update(unsigned int frame);
private:
    void set_parent_data();
    bool anim_exists();
    bool parent_exists();
    void update_sprites();
};

double angle_difference(double angle_a, double angle_b);
double lengthdir_x(double length, double angle);
double lengthdir_y(double length, double angle);
double point_direction(double x1, double y1, double x2, double y2);
double point_distance(double x1, double y1, double x2, double y2);

#endif	/* BONE_H */

