/* 
 * File:   Skeleton.cpp
 * Author: Trixt0r
 * 
 * Created on 19. April 2012, 20:40
 */

#include "Skeleton.h"

using namespace std;

Skeleton::Skeleton() {
    this->bones = new vector<Bone*>();
    this->animation = 0L;
    this->frame = 0;
    this->count = 0;
    this->frame_speed = 1;
}

Skeleton::Skeleton(const Skeleton& orig) {
}

Skeleton::~Skeleton() {
    delete this->bones;
    delete this->animation;
}

void Skeleton::update(double x, double y){
    count = fmod(animation->get_frames()+count+frame_speed,animation->get_frames());
    frame = floor(count);
    for(int i = 0; i < this->bones->size(); i++){
        this->bones->at(i)->skel_x = x;
        this->bones->at(i)->skel_y = y;
        this->bones->at(i)->update(frame);
    }
}

void Skeleton::add_bone(Bone* bone){
    this->bones->push_back(bone);
    bone->index = this->bones->size()-1;
}

void Skeleton::flip_hor(){
    for(int i = 0; i < this->bones->size(); i++){
        this->bones->at(i)->xscale *= -1;
        this->bones->at(i)->xrot = fmod(this->bones->at(i)->xrot+180,360);
    }
}

void Skeleton::flip_ver(){
    for(int i = 0; i < this->bones->size(); i++){
        this->bones->at(i)->yscale *= -1;
        this->bones->at(i)->yrot = fmod(this->bones->at(i)->yrot+180,360);
    }
}

void Skeleton::set_offset(double x, double y){
    for(int i = 0; i < this->bones->size(); i++){
        this->bones->at(i)->origin_y = x;
        this->bones->at(i)->origin_y = y;
    }
}

bool Skeleton::is_last_frame(){
    if(this->anim_exists()) return this->frame == this->animation->get_frames();
    else return false;
}

bool Skeleton::anim_exists(){
    return this->animation != 0L;
}