/* 
 * File:   Skeleton.h
 * Author: Trixt0r
 *
 * Created on 19. April 2012, 20:40
 */

#ifndef SKELETON_H
#define	SKELETON_H

#include <math.h>
#include <vector>
#include "Bone.h"
#include "Animation.h"

class Skeleton {
public:
    Skeleton();
    Skeleton(const Skeleton& orig);
    virtual ~Skeleton();
    
    std::vector<Bone*> *bones;
    Animation *animation;
    unsigned int frame;
    double count,frame_speed;
    
    void update(double x, double y);
    void add_bone(Bone *bone);
    void flip_hor();
    void flip_ver();
    void set_offset(double x, double y);
    bool is_last_frame();
private:
    bool anim_exists();
};

#endif	/* SKELETON_H */

